''----------------------------------------------------------------------------''                                                                                                       ''
''                                                                            ''
''                   Multimetr 2012 Piotr Rosenbaum                          ''
''                   mail: piotr.rosenbaum@gmail.com                          ''
''                                                                            ''
''                                                                            ''
''----------------------------------------------------------------------------''                                                                                                       ''
''----------------------------------------------------------------------------''


$regfile = "M8def.dat"
$crystal = 1000000

Config Adc = Single , Prescaler = Auto , Reference = Internal       'konfiguracja wewntrznego przetwornika ADC

Start Adc                                                   'uruchomienie przetwornika ADC


'--------------------DEKLARACJA ZMIENNYCH--------------------------------------'
Dim Wart_ac As Word
Dim V As Single , I As Single , Vv As Single , Ia As Single
Dim Wart_pr As String * 3 , Wart_nap As Word
Dim Wart_str As String * 3 , W As Single
Dim Wart_wat As String * 3


'------------------------KONFIGURACJA LCD--------------------------------------'

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2


Cls
Cursor Off
Lcd ; Spc(3) ; "Multimetr"
Lowerline
Lcd ; Spc(3) ; "by Peter507"                                'wywietlanie ekranu pocztkowego
Wait 1
Cls


'------------------------POCZTEK PTLI GWNEJ--------------------------------'

Do

   Wart_ac = Getadc(0)                                      'pobranie wartoci mierzonego napicia
   Wart_nap = Getadc(1)                                     'pobranie wartoci mierzonego napicia do obliczenia prdu

   V = Wart_nap * 0.0025                                    'unormowaanie zmierzonego napicia i napicia do pomiaru prdu
   Vv = Wart_ac * 0.025

   I = V / 0.1                                              'dzielenie zmierzonego spadku napicia na rezystorze (prawo Ohma)
   W = I * Vv


         Wart_str = Fusing(vv , "#.&&")
         Wart_pr = Fusing(i , "#.&&&")                      'zaokrlglanie do dwch miejsc po przecinku wartoci wywietlanych na LCD
         Wart_wat = Fusing(w , "#.&&")

         Home Upper
         Lcd "U" ; Wart_str ; "V" ; Spc(1) ; "I" ; Wart_pr ; "A" ; Spc(1)
         Lowerline
         Lcd "P" ; Wart_wat ; "W" ; Spc(9)                  'wywietlanie pomierzonych wartoci
         Wait 1





Loop
End
'----------------------------KONIEC PTLI GWNEJ------------------------------'